
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   order_corners
%   by Petra Kocmanova
%   last modified: 23.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [ pp, xx ] = order_corners(grid_p,dx)
%function reoder images coordinates of corners and create matrix of object coordinates 

grid_p=grid_p(1:3,:);
T_grid_p=grid_p;
%dx=0.1;

%reference point
[~,i] = min(T_grid_p(1,:));%find column index with smallest value
ref_point=T_grid_p(:,i);%point with smallest x
T_grid_p(:,i)=[];% delete ref_point from T_grid_p

%nearest point 1
dif=bsxfun(@minus,ref_point,T_grid_p);
dist=sum(dif.^2,1);
[~,idf]=min(dist);
point1=T_grid_p(:,idf);
T_grid_p(:,idf)=[];
[line1, line_p1, T_grid_p] = extract_line(ref_point, point1, T_grid_p);

%nearest point 2
dif=bsxfun(@minus,ref_point,T_grid_p);
dist=sum(dif.^2,1);
[~,idf]=min(dist);
point2=T_grid_p(:,idf);
T_grid_p(:,idf)=[];
[line2, line_p2, T_grid_p] = extract_line(ref_point, point2, T_grid_p);

%nearest point 3
dif=bsxfun(@minus,ref_point,T_grid_p);
dist=sum(dif.^2,1);
[~,idf]=min(dist);
point3=T_grid_p(:,idf);
T_grid_p(:,idf)=[];
[line3, line_p3, T_grid_p] = extract_line(ref_point, point3, T_grid_p);

[~,i]=max(abs([line1(1),line2(1),line3(1)]));

if i==1
    line_p=line_p1;
elseif i==2
    line_p=line_p2;
else 
    line_p=line_p3;
end


%find the highest point in the line
[~,i]=min(line_p(2,:));
ref_point=line_p(:,i);
line_p(:,i)=[];


i=point_idx(ref_point,grid_p);
pp=ref_point;
xx=[0;0;0];
grid_p(:,i)=[];

%find first horizontal line
T_grid_p=grid_p;
i=point_idx(line_p,T_grid_p);
T_grid_p(:,i)=[];

[~,i] = min(T_grid_p(2,:));
point = T_grid_p(:,i);
T_grid_p(:,i) = [];
[line,line_p] = extract_line(ref_point,point,T_grid_p);

%Add line
x_corner_number = size(line_p,2);
dist2 = sum(bsxfun(@minus,line_p,ref_point).^2);
[~,i]=sort(dist2);
line_p = line_p(:,i);

xi=1;
yi=0;

for i=2:size(line_p,2)
    dif=bsxfun(@minus,grid_p,line_p(:,i));
    dist=sum(dif.^2,1);
    [~,idf]=min(dist);
    pp = [pp, grid_p(:,idf)];
    xx = [xx, dx*[xi;yi;0]];
    xi = xi+1; 
    grid_p(:,idf) = [];
end
  
%Add other lines
yi=1;
while(~isempty(grid_p))
    
    T_grid_p = grid_p;
    dif=bsxfun(@minus,ref_point,T_grid_p);
    dist=sum(dif.^2,1);
    [~,idf]=min(dist);
    point1=T_grid_p(:,idf);
    T_grid_p(:,idf)=[];
    
    res = line(1:2)'*point1(1:2);
    line = [line(1:2); -res];

    fits_T = abs(sum( bsxfun(@times, T_grid_p, line) ));
    [~,idf] = min(fits_T);
    point2 = T_grid_p(:,idf);
    T_grid_p(:,idf) = [];
    
    %Get line
    [line,line_p] = extract_line2(point1,point2,T_grid_p,x_corner_number);
    
    %Add all points on the line
    [~,i]=sort(line_p(1,:));
    line_p = line_p(:,i);
    
    xi=0;
    for i=1:size(line_p,2)
        
        
        dif=bsxfun(@minus,line_p(:,i),grid_p);
        dist=sum(dif.^2,1);
        [~,idf]=min(dist);
        
        
        pp = [pp, grid_p(:,idf)];
        xx = [xx, dx*[xi;yi;0]];
        xi = xi+1;
        grid_p(:,idf) = [];
    end

    ref_point = line_p(:,1); %save for next line
    yi=yi+1;
  end

  pp = pp(1:3,:);
end
  


function idx=point_idx(p,pset)
grid_p_size = size(p,2);
idx = zeros(1,grid_p_size);

for i=1:grid_p_size
    e = pset(1,:) == p(1,i) & pset(2,:) == p(2,i);
    idx_i = find(e);
    idx(i) = idx_i;    
end
end

function [line1, line_p1, pp] = extract_line(ref_point, near_p, T_grid_p)
%extract line 1
pp=T_grid_p;
line_p1=[ref_point,near_p];
[~,~,V]=svd(line_p1');
line1 = V(:,end) / norm(V(1:2,end));

%add points to line1
line_found=false;

while(~line_found && size(T_grid_p,2)>0)
    
near2line1=abs(sum(bsxfun(@times,pp,line1)));
[~,idf]=min(near2line1);
line_p11=[line_p1,pp(:,idf)];
[~,~,V]=svd(line_p11');
line11 = V(:,end) / norm(V(1:2,end));

dist_ref=sqrt(sum(bsxfun(@minus,ref_point,line_p11(:,2:end)).^2));
fit_threshold=min(dist_ref)/10;

fit_prev=abs(sum(bsxfun(@times,line_p11,line11)))<fit_threshold;
if(~all(fit_prev))
    line_found=true;
else
    line1=line11;
    line_p1=line_p11;
    pp(:,idf)=[];
end
end

end

%This version extracts a line with the given point count
function [line,line_p,pp]=extract_line2(ref_point,point2,grid_p,min_pcount)
    if(size(grid_p,2)+2 < min_pcount)
      error('Insufficient points to construct line.');
    end
    
    %Start line with two points
    pp = grid_p;
    line_p = [ref_point,point2];
    
    
    [~,~,V]=svd(line_p');
    line = V(:,end) / norm(V(1:2,end));

    
    %Add points to line
    while(size(line_p,2)<min_pcount)
        %Calculate line with new point
        
        fits_temp = abs(sum( bsxfun(@times, pp, line) ));
        [~,idf] = min(fits_temp);
        
        line_p = [line_p,pp(:,idf)];
        [~,~,V]=svd(line_p');
        line = V(:,end) / norm(V(1:2,end));
        pp(:,idf) = [];
    end
end

