
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   select_corners
%   by Petra Kocmanova
%   last modified: 27.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [] = select_corners(handles,im_k)
%select corners in images for calibration


%images_number - number of images for calibration
%c_number - number of cameras for calibration

%input
global path_calibration_data
global cameras
global images
global use_im
global square_size
global square_number_x
global square_number_y
global skip

n_camera=get(handles.popupmenu1,'Value');

switch n_camera
    case 1
        k=1;
    case 2
        k=2;
    case 3
        k=3;
    case 4
        k=4;
    case 5
        k=5;
    otherwise
        disp('Choose camera for corner extraction')
end


% 
% if num2str(im_k(1,k)) < 10
    im=imread([path_calibration_data '\calibration_data\00' num2str(im_k(1,k)) cameras(k,1).name]);
% elseif num2str(im_k(1,k)) < 100
%     im=imread([path_calibration_data '\calibration_data\0' num2str(im_k(1,k)) cameras(k,1).name]);
% else
%     im=imread([path_calibration_data '\calibration_data\' num2str(im_k(1,k)) cameras(k,1).name]);
% end

[grid_p]=click_ima_calib_rufli_k(im_k(1,k),im,true,cameras(k,1).search_window,...
    cameras(k,1).search_window,square_number_x,square_number_y,handles);



imshow(im, 'Parent', handles.axes1);
hold on


if isempty(grid_p)==1
    h=questdlg('Automatic corner extraction failed',...
        'Manual extraction', ...
        'Manual extraction','Manual extraction');
    switch h
        case 'Manual extraction'
            [grid_p]=extract_grid_up(handles,im,cameras(k,1).search_window,...
                cameras(k,1).search_window,cameras(k,1).fc0, [size(im,1)/2+0.5 size(im,2)/2+0.5],[0 0 0 0],0.1,0.1);
            
            [ pp, xx ] = order_corners([grid_p(1:2,:); ones(1,size(grid_p,2))],square_size);
            
            
%         case 'Skip this image'
%             skip=1;
%             pp=[];
%             xx=[];
%             Select_corners_GUI()
            
    end
else
    plot(handles.axes1,(grid_p(4,:)+1),...
        (grid_p(5,:)+1),'xr','linewidth',2,'MarkerSize',8)
    hold on
    plot(handles.axes1,(grid_p(1,:)+1),...
        (grid_p(2,:)+1),'+b','linewidth',2,'MarkerSize',12)
    title('Red: initial detection, Blue: enhanced')
    hold off
    [ pp, xx ] = order_corners(grid_p(1:3,:),square_size);
end
%images(im_k(1,k),k).grid_p=grid_p(1:3,:);

images(im_k(1,k),k).grid_p=pp;
images(im_k(1,k),k).grid_x=xx;
    
if skip == 0
    use_im(k,im_k(1,k))=true;
    set(handles.uitable1, 'Data', use_im);
else
    use_im(k,im_k(1,k))=false;
%     imshow(im, 'Parent', handles.axes1);

end

end

